Attribute VB_Name = "modEnemies"
'
'  Wall of the Words is Copyright (c) 2008 Robson
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful, but
'  WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'  General Public License for more details.
'
'  The license can be viewed at http://www.gnu.org/licenses/gpl.html
'
' all variables are declared
Option Explicit
Private Type ENEMY
    bytX As Byte
    bytY As Byte
    blnActive As Boolean
End Type
Public arrEnemies() As ENEMY
Public intTurn As Integer
Private intNextSpawn As Integer

Public Sub EnemySetup()
    ReDim arrEnemies(0)
    NewEnemy
    If bytLevel > 1 Then
        ReDim Preserve arrEnemies(1)
        NewEnemy
    End If
End Sub

Private Sub NewEnemy()
    Dim blnOkay As Boolean
    With arrEnemies(UBound(arrEnemies))
        .blnActive = True
        blnOkay = False
        Do
            .bytX = RNG(1, UBound(arrBattlefield, 1) - 2)
            If Not arrBattlefield(.bytX, .bytY).blnDefenceWall And _
               Not arrBattlefield(.bytX, .bytY).blnDefenceWallTemporary And _
               Not arrBattlefield(.bytX, .bytY).blnTree And _
               Not arrBattlefield(.bytX, .bytY).blnWater And _
               Not arrBattlefield(.bytX, .bytY).blnEnemy Then
                blnOkay = True
            End If
        Loop Until blnOkay
        .bytY = 0
    End With
    intNextSpawn = intTurn + RNG(bytEnemyFrequencyLow, bytEnemyFrequencyHigh)
    SetEnemyPositions
End Sub

Public Sub SetEnemyPositions()
    Dim X As Byte, Y As Byte
    For X = 0 To UBound(arrBattlefield, 1)
        For Y = 0 To UBound(arrBattlefield, 2)
            arrBattlefield(X, Y).blnEnemy = False
        Next
    Next
    For X = 0 To UBound(arrEnemies)
        With arrEnemies(X)
            If .blnActive Then
                arrBattlefield(.bytX, .bytY).blnEnemy = True
            End If
        End With
    Next
End Sub
Public Sub EnemyActions()
    Dim N As Integer, A As Integer
    Dim blnMoved As Boolean
    For N = 0 To UBound(arrEnemies)
        With arrEnemies(N)
            If .blnActive Then
                blnMoved = False
                If arrBattlefield(.bytX, .bytY + 1).blnCastleWall Then
                    blnInGame = False
                    Status "Failed: The attackers have reached your castle! Right-click to restart"
                    For A = 0 To frmMain.picLetter.UBound
                        frmMain.picLetter(A).DragMode = 0
                    Next
                ElseIf arrBattlefield(.bytX, .bytY + 1).blnDefenceWall Then
                    blnMoved = True
                    arrBattlefield(.bytX, .bytY + 1).intHitPoints = arrBattlefield(.bytX, .bytY + 1).intHitPoints - RNG(1, bytMaxDamage)
                    If arrBattlefield(.bytX, .bytY + 1).intHitPoints <= 0 Then
                        arrBattlefield(.bytX, .bytY + 1).blnDefenceWall = False
                        arrBattlefield(.bytX, .bytY + 1).blnGrass = True
                        arrBattlefield(.bytX, .bytY + 1).intHitPoints = 0
                        arrBattlefield(.bytX, .bytY + 1).strLetter = ""
                        arrBattlefield(.bytX, .bytY + 1).blnHitMajor = True
                    Else
                        arrBattlefield(.bytX, .bytY + 1).blnHitMinor = True
                    End If
                Else
                    If arrBattlefield(.bytX, .bytY + 1).blnGrass And _
                       Not arrBattlefield(.bytX, .bytY + 1).blnWater And _
                       Not arrBattlefield(.bytX, .bytY + 1).blnTree And _
                       Not arrBattlefield(.bytX, .bytY + 1).blnEnemy Then
                        blnMoved = True
                        .bytY = .bytY + 1
                    End If
                    If RNG(1, 2) = 1 Then
                        If Not blnMoved Then
                            If arrBattlefield(.bytX + 1, .bytY).blnGrass And _
                               Not arrBattlefield(.bytX + 1, .bytY).blnWater And _
                               Not arrBattlefield(.bytX + 1, .bytY).blnTree And _
                               Not arrBattlefield(.bytX + 1, .bytY).blnEnemy Then
                                blnMoved = True
                                If arrBattlefield(.bytX + 1, .bytY).blnDefenceWall Then
                                    arrBattlefield(.bytX + 1, .bytY).intHitPoints = arrBattlefield(.bytX + 1, .bytY).intHitPoints - RNG(1, bytMaxDamage)
                                    If arrBattlefield(.bytX + 1, .bytY).intHitPoints <= 0 Then
                                        arrBattlefield(.bytX + 1, .bytY).blnDefenceWall = False
                                        arrBattlefield(.bytX + 1, .bytY).blnGrass = True
                                        arrBattlefield(.bytX + 1, .bytY).intHitPoints = 0
                                        arrBattlefield(.bytX + 1, .bytY).strLetter = ""
                                        arrBattlefield(.bytX + 1, .bytY).blnHitMajor = True
                                    Else
                                        arrBattlefield(.bytX + 1, .bytY).blnHitMinor = True
                                    End If
                                Else
                                    .bytX = .bytX + 1
                                End If
                            End If
                        End If
                        If Not blnMoved Then
                            If arrBattlefield(.bytX - 1, .bytY).blnGrass And _
                               Not arrBattlefield(.bytX - 1, .bytY).blnWater And _
                               Not arrBattlefield(.bytX - 1, .bytY).blnTree And _
                               Not arrBattlefield(.bytX - 1, .bytY).blnEnemy Then
                                blnMoved = True
                                If arrBattlefield(.bytX - 1, .bytY).blnDefenceWall Then
                                    arrBattlefield(.bytX - 1, .bytY).intHitPoints = arrBattlefield(.bytX - 1, .bytY).intHitPoints - RNG(1, bytMaxDamage)
                                    If arrBattlefield(.bytX - 1, .bytY).intHitPoints <= 0 Then
                                        arrBattlefield(.bytX - 1, .bytY).blnDefenceWall = False
                                        arrBattlefield(.bytX - 1, .bytY).blnGrass = True
                                        arrBattlefield(.bytX - 1, .bytY).intHitPoints = 0
                                        arrBattlefield(.bytX - 1, .bytY).strLetter = ""
                                        arrBattlefield(.bytX - 1, .bytY).blnHitMajor = True
                                    Else
                                        arrBattlefield(.bytX - 1, .bytY).blnHitMinor = True
                                    End If
                                Else
                                    .bytX = .bytX - 1
                                End If
                            End If
                        End If
                    Else
                        If Not blnMoved Then
                            If arrBattlefield(.bytX - 1, .bytY).blnGrass And _
                               Not arrBattlefield(.bytX - 1, .bytY).blnWater And _
                               Not arrBattlefield(.bytX - 1, .bytY).blnTree And _
                               Not arrBattlefield(.bytX - 1, .bytY).blnEnemy Then
                                blnMoved = True
                                If arrBattlefield(.bytX - 1, .bytY).blnDefenceWall Then
                                    arrBattlefield(.bytX - 1, .bytY).intHitPoints = arrBattlefield(.bytX - 1, .bytY).intHitPoints - RNG(1, bytMaxDamage)
                                    If arrBattlefield(.bytX - 1, .bytY).intHitPoints <= 0 Then
                                        arrBattlefield(.bytX - 1, .bytY).blnDefenceWall = False
                                        arrBattlefield(.bytX - 1, .bytY).blnGrass = True
                                        arrBattlefield(.bytX - 1, .bytY).intHitPoints = 0
                                        arrBattlefield(.bytX - 1, .bytY).strLetter = ""
                                        arrBattlefield(.bytX - 1, .bytY).blnHitMajor = True
                                    Else
                                        arrBattlefield(.bytX - 1, .bytY).blnHitMinor = True
                                    End If
                                Else
                                    .bytX = .bytX - 1
                                End If
                            End If
                        End If
                        If Not blnMoved Then
                            If arrBattlefield(.bytX + 1, .bytY).blnGrass And _
                               Not arrBattlefield(.bytX + 1, .bytY).blnWater And _
                               Not arrBattlefield(.bytX + 1, .bytY).blnTree And _
                               Not arrBattlefield(.bytX + 1, .bytY).blnEnemy Then
                                blnMoved = True
                                If arrBattlefield(.bytX + 1, .bytY).blnDefenceWall Then
                                    arrBattlefield(.bytX + 1, .bytY).intHitPoints = arrBattlefield(.bytX + 1, .bytY).intHitPoints - RNG(1, bytMaxDamage)
                                    If arrBattlefield(.bytX + 1, .bytY).intHitPoints <= 0 Then
                                        arrBattlefield(.bytX + 1, .bytY).blnDefenceWall = False
                                        arrBattlefield(.bytX + 1, .bytY).blnGrass = True
                                        arrBattlefield(.bytX + 1, .bytY).intHitPoints = 0
                                        arrBattlefield(.bytX + 1, .bytY).strLetter = ""
                                        arrBattlefield(.bytX + 1, .bytY).blnHitMajor = True
                                    Else
                                        arrBattlefield(.bytX + 1, .bytY).blnHitMinor = True
                                    End If
                                Else
                                    .bytX = .bytX + 1
                                End If
                            End If
                        End If
                    End If
                End If
                SetEnemyPositions
            End If
        End With
    Next
    intTurn = intTurn + 1
    If intTurn = intNextSpawn Then
        ReDim Preserve arrEnemies(UBound(arrEnemies) + 1)
        NewEnemy
    End If
    If blnInGame And intTurn > modGame.bytTurnRetreat Then
        blnWonLevel = True
    End If
End Sub

